automake-patches
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

FYI: Never overwrite COPYING


From: Alexandre Duret-Lutz
Subject: FYI: Never overwrite COPYING
Date: Sun, 09 Nov 2003 12:55:17 +0100
User-agent: Gnus/5.1003 (Gnus v5.10.3) Emacs/21.3 (gnu/linux)

I'm checking this in.

2003-11-09  Alexandre Duret-Lutz  <address@hidden>

        * automake.in (check_gnu_standards): Install COPYING only if
        none of COPYING, COPYING.LIB, or COPYING.LESSER exist.  Do not
        overwrite the license otherwise.
        * tests/Makefile.am (TESTS): Add license.test.
        * tests/license.test: New file.

Index: NEWS
===================================================================
RCS file: /cvs/automake/automake/NEWS,v
retrieving revision 1.238
diff -u -r1.238 NEWS
--- NEWS        9 Nov 2003 00:10:50 -0000       1.238
+++ NEWS        9 Nov 2003 11:51:25 -0000
@@ -182,6 +182,14 @@
     it in the source tree too), and it caused several problems, varying
     from mere annoyance to portability issues.
 
+  - COPYING, COPYING.LIB, and COPYING.LESSER are no longer overwritten
+    when --add-missing and --force-missing are used.  For backward
+    compatibility --add-missing will continue to install COPYING (in
+    `gnu' strictness) when none of these three files exist, but this
+    use is deprecated: you should better choose a license yourself and
+    install it once for all in your source tree (and in your code
+    management system).
+
 * Miscellaneous
 
   - The Automake manual is now distributed under the terms of the GNU FDL.
Index: automake.in
===================================================================
RCS file: /cvs/automake/automake/automake.in,v
retrieving revision 1.1511
diff -u -r1.1511 automake.in
--- automake.in 8 Nov 2003 13:01:13 -0000       1.1511
+++ automake.in 9 Nov 2003 11:51:29 -0000
@@ -4645,15 +4645,22 @@
   if ($relative_dir eq '.')
     {
       # In top level (or only) directory.
+      require_file ("$am_file.am", GNU,
+                   qw/INSTALL NEWS README AUTHORS ChangeLog/);
 
       # Accept one of these three licenses; default to COPYING.
-      my $license = 'COPYING';
-      foreach (qw /COPYING.LIB COPYING.LESSER/)
+      # Make sure we do not overwrite an existing license.
+      my $license;
+      foreach (qw /COPYING COPYING.LIB COPYING.LESSER/)
        {
-         $license = $_ if -f $_;
+         if (-f $_)
+           {
+             $license = $_;
+             last;
+           }
        }
-      require_file ("$am_file.am", GNU, $license,
-                   qw/INSTALL NEWS README AUTHORS ChangeLog/);
+      require_file ("$am_file.am", GNU, 'COPYING')
+       unless $license;
     }
 
   for my $opt ('no-installman', 'no-installinfo')
Index: tests/Makefile.am
===================================================================
RCS file: /cvs/automake/automake/tests/Makefile.am,v
retrieving revision 1.523
diff -u -r1.523 Makefile.am
--- tests/Makefile.am   8 Nov 2003 13:01:13 -0000       1.523
+++ tests/Makefile.am   9 Nov 2003 11:51:32 -0000
@@ -275,6 +275,7 @@
 libtool5.test \
 libtool6.test \
 libtool7.test \
+license.test \
 link_c_cxx.test        \
 link_dist.test \
 link_fc.test \
Index: tests/license.test
===================================================================
RCS file: tests/license.test
diff -N tests/license.test
--- /dev/null   1 Jan 1970 00:00:00 -0000
+++ tests/license.test  9 Nov 2003 11:51:32 -0000
@@ -0,0 +1,67 @@
+#! /bin/sh
+# Copyright (C) 2003  Free Software Foundation, Inc.
+#
+# This file is part of GNU Automake.
+#
+# GNU Automake is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# GNU Automake is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with Automake; see the file COPYING.  If not, write to
+# the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+# Boston, MA 02111-1307, USA.
+
+# Make sure COPYING is not overwritten, even with -a -f.
+
+required=makeinfo
+. ./defs || exit 1
+
+set -e
+
+echo AC_OUTPUT >>configure.in
+cat >Makefile.am <<\EOF
+test1: distdir
+       grep 'GNU GENERAL PUBLIC LICENSE' $(distdir)/COPYING
+test2: distdir
+       grep 'MY-OWN-LICENSE' $(distdir)/COPYING
+test3: distdir
+       test ! -f $(distdir)/COPYING
+       grep 'MY-OWN-LICENSE' $(distdir)/COPYING.LIB
+EOF
+
+:> NEWS
+:> AUTHORS
+:> ChangeLog
+:> README
+
+test ! -f COPYING
+
+$ACLOCAL
+$AUTOCONF
+$AUTOMAKE --gnu --add-missing
+
+./configure
+$MAKE test1
+
+# rm before echo, because COPYING is likely to be a symlink to
+# the real COPYING...
+rm -f COPYING
+echo 'MY-OWN-LICENSE' >COPYING
+$MAKE test2
+
+$AUTOMAKE --gnu --add-missing --force-missing
+./configure
+$MAKE test2
+
+rm -f COPYING
+echo 'MY-OWN-LICENSE' >COPYING.LIB
+$AUTOMAKE --gnu --add-missing --force-missing
+./configure
+$MAKE test3

-- 
Alexandre Duret-Lutz





reply via email to

[Prev in Thread] Current Thread [Next in Thread]